#include "filehandler.h"
#include <sys/stat.h>

bool UFileHandler::rmFile(const std::string &sFilename)
{
	std::string sTemp = "rm -f \"" + sFilename + "\"";
	int iResult = system(sTemp.c_str());
	return (iResult == 0);
}

bool UFileHandler::mkDir(const std::string &sDir)
{
	std::string sTemp = "mkdir \"" + sDir + "\"";
	int iResult = system(sTemp.c_str());
	return (iResult == 0);
}

bool UFileHandler::isExecutable(const std::string &sFilename)
{
	return !(access(sFilename.c_str(), X_OK) < 0);
}

bool UFileHandler::isSymlink(const std::string &sFilename)
{
	struct stat oStat;
	lstat(sFilename.c_str(), &oStat);
	return (S_ISLNK(oStat.st_mode) ? true : false);
}

bool UFileHandler::isDir(const std::string &sDir)
{
	struct stat oStat;
	stat(sDir.c_str(), &oStat);
	return (S_ISDIR(oStat.st_mode) ? true : false);
}

bool UFileHandler::isFile(const std::string &sFilename)
{
	struct stat oStat;
	stat(sFilename.c_str(), &oStat);
	return (S_ISREG(oStat.st_mode) ? true : false);
}

std::vector<std::string> UFileHandler::importFile(const std::string &sFilename)
{
	std::vector<std::string> sReturn;
	std::string sCurrent;
	char sLine[1024];
	FILE *oFile;
	oFile = fopen(sFilename.c_str(), "r");
	while (fgets(sLine, sizeof(sLine) - 1, oFile) != NULL)
	{
		sCurrent = sLine;
		sReturn.push_back(sCurrent.substr(0, sCurrent.length() - 1));
	}
	fclose(oFile);
	return sReturn;
}

