#ifndef FILESETTINGSPANEL_H
#define FILESETTINGSPANEL_H
#include <wx/wx.h>
#include "settings.h"

class FileSettingsPanel : public wxPanel
{
public:
	FileSettingsPanel(wxWindow *oParent, Settings *oNewSettings);

private:
	// Sizers.
	wxBoxSizer *oWindowSizer;
	wxBoxSizer *oMainSizer;
	wxStaticBoxSizer *oExtensionSizer;
	wxBoxSizer *oButtonSizer;
	wxFlexGridSizer *oInputSizer;

	// General variables.
	Settings *oSettings;
	
	// Controls.
	wxStaticText *lblType;
	wxStaticText *lblTypeValue;
	wxListBox *oFileList;
	wxStaticText *lblEnding;
	wxStaticText *lblRun;
	wxStaticText *lblTerminal;
	wxTextCtrl *txtEnding;
	wxTextCtrl *txtRun;
	wxCheckBox *btnTerminal;
	wxButton *btnAdd;
	wxButton *btnChange;
	wxButton *btnDelete;
	wxStaticBox *oExtensionBox;
	
	// Functions.
	void readSettings();
	void loadSelection(const wxString &sExtension);
	
	// Event handlers.
	void on_btnAdd(wxCommandEvent &oEvent);
	void on_btnChange(wxCommandEvent &oEvent);
	void on_btnDelete(wxCommandEvent &oEvent);
	void on_oFileList(wxCommandEvent &oEvent);

	DECLARE_EVENT_TABLE()
};

#endif

