#ifndef SETTINGS_H
#define SETTINGS_H
#include <vector>
#include <string>

class Settings
{
public:
	// Types.
	static const int TYPE_FILE = 0;
	static const int TYPE_EXEC = 1;
	static const int TYPE_FOLDER = 2;
	
	Settings();
	
	// File : Exec : Folder
	std::string getRunString(const std::string &sEnding);
	std::string getEnding(const std::string &sItem);
	bool exists(const std::string &sEnding);
	bool getTerminal(const std::string &sEnding);
	
	// File
	bool addFileEnding(const std::string &sEnding, const std::string &sRun, bool bTerminal);
	bool changeFileEnding(const std::string &sEnding, const std::string &sNewEnding, const std::string &sNewRun, bool bNewTerminal);
	bool deleteFileEnding(const std::string &sEnding);
	std::vector<std::string> getFileEndings();

	int count();
	void load();
	void save();
	
	std::string getGeneral(const std::string &sVarname);
	void setGeneral(const std::string &sVarname, const std::string &sValue);

	std::string getKeySignal(int iCode);

private:
	std::string sConfigPath;
	
	std::vector<std::string> sEndingVector;
	std::vector<std::string> sRunVector;
	std::vector<bool> bTerminalVector;
	
	std::vector<std::string> sGeneralKeys;
	std::vector<std::string> sGeneralValues;
};

#endif

