#ifndef SETTINGSWINDOW_H
#define SETTINGSWINDOW_H
#include <wx/wx.h>
#include <wx/notebook.h>
#include "settings.h"
#include "filesettingspanel.h"
#include "execsettingspanel.h"

class SettingsWindow : public wxFrame
{
public:
	SettingsWindow(wxFrame *oParent, const wxString &sTitle, Settings *oNewSettings);
	
private:
	// General variables.
	Settings *oSettings;
	
	// Sizers.
	wxBoxSizer *oWindowSizer;
	wxBoxSizer *oMainSizer;
	wxBoxSizer *oControlSizer;
	wxFlexGridSizer *oFieldSizer;
	wxBoxSizer *oCloseSizer;
	wxBoxSizer *oListSizer;
	wxBoxSizer *oGeneralRadioSizer;
	wxStaticBoxSizer *oGeneralSizer;
	wxBoxSizer *oButtonSizer;
	
	// Controls.
	FileSettingsPanel *oFileSettingsPanel;
	ExecSettingsPanel *oExecSettingsPanel;
	wxStaticBox *oGeneralBox;
	wxStaticText *lblInfo;
	wxStaticText *lblDefaultApp;
	wxStaticText *lblScreenMargin;
	wxTextCtrl *txtDefaultApp;
	wxTextCtrl *txtScreenMargin;
	wxCheckBox *btnShowMenubar;
	wxCheckBox *btnShowLocation;
	wxCheckBox *btnShowToolbar;
	wxCheckBox *btnAutoFitTree;
	wxButton *btnFiles;
	wxButton *btnExec;
	wxButton *btnFolders;
	wxButton *btnOK;
	wxButton *btnCancel;
	wxPanel *oPanel;
	
	// Functions.
	void readSettings();
	void setPanel(wxWindow *oWindow);
	
	// Event handlers.
	void on_btnOK(wxCommandEvent &oEvent);
	void on_btnCancel(wxCommandEvent &oEvent);
	void on_txtDefaultApp(wxCommandEvent &oEvent);
	void on_txtScreenMargin(wxCommandEvent &oEvent);
	void on_this_close(wxCloseEvent &oEvent);
	void on_btnShowMenubar(wxCommandEvent &oEvent);
	void on_btnShowLocation(wxCommandEvent &oEvent);
	void on_btnShowToolbar(wxCommandEvent &oEvent);
	void on_btnAutoFitTree(wxCommandEvent &oEvent);
	void on_btnFiles(wxCommandEvent &oEvent);
	void on_btnExec(wxCommandEvent &oEvent);
	void on_btnFolders(wxCommandEvent &oEvent);

	DECLARE_EVENT_TABLE()
};

#endif

