#include "timemonitor.h"
#include "filehandler.h"
#include <sys/stat.h>

void UTimeMonitor::delTime(const std::string &sDir)
{
	std::vector<std::string> sNewDirVector;
	std::vector<time_t> iNewTimeVector;
	for (unsigned int i = 0; i < sDirVector.size(); i++)
	{
		if (sDirVector[i] != sDir)
		{
			sNewDirVector.push_back(sDirVector[i]);
			iNewTimeVector.push_back(iTimeVector[i]);
		}
	}
	sDirVector = sNewDirVector;
	iTimeVector = iNewTimeVector;
}

bool UTimeMonitor::checkTime(const std::string &sDir)
{
	bool bChanged = false;
	bool bFound = false;
	time_t iTime;

	if (!UFileHandler::isDir(sDir))
	{
		return false;
	}
	
	struct stat oStat;
	stat(sDir.c_str(), &oStat),
	iTime = oStat.st_mtime;
	for (unsigned int i = 0; i < sDirVector.size(); i++)
	{
		if (sDir == sDirVector[i])
		{
			bFound = true;
			if (iTime != iTimeVector[i])
			{
				iTimeVector[i] = iTime;
				bChanged = true;
			}
		}
	}
	if (!bFound)
	{
		sDirVector.push_back(sDir);
		iTimeVector.push_back(iTime);
	}
	return bChanged;
}

