#include <wx/wx.h>
#include "constants.h"
#include "uthread.h"
#include "filetree.h"

UThread::UThread(UFiletree *oNewTree) : wxThread()
{
	iInt = 0;
	this->oTree = oNewTree;
}

void UThread::checkChanges()
{
	// Make sure something is selected.
	if (!oTree->somethingSelected())
	{
		oTree->selectTreeItem(oTree->GetRootItem());
	}
	
	wxTreeItemId iRoot = oTree->GetRootItem();
	wxTreeItemId iSelected;
	wxString sDir;
	std::vector<wxTreeItemId> iReload;
	std::vector<wxString> sReloadDirs;
	sDir = oTree->getFullpath(iRoot);
	if (oTree->oTimeMonitor.checkTime((char *)sDir.c_str()))
	{
		iReload.insert(iReload.begin(), iRoot);
		sReloadDirs.insert(sReloadDirs.begin(), sDir);
	}
	wxTreeItemId iCurrent = iRoot;
	while (iCurrent = oTree->getNextID(iCurrent))
	{
		wxMutexGuiEnter();
		sDir = oTree->getFullpath(iCurrent);
		wxMutexGuiLeave();
		if (oTree->oTimeMonitor.checkTime((char *)sDir.c_str()))
		{
			iReload.insert(iReload.begin(), iCurrent);
			sReloadDirs.insert(sReloadDirs.begin(), sDir);
		}
	}
	if (iReload.size() > 0)
	{
		for (unsigned int i = 0; i < iReload.size(); i++)
		{
			wxMutexGuiEnter();
			oTree->ReloadDir(iReload[i], sReloadDirs[i], true);
			wxMutexGuiLeave();
		}
	}
}


void *UThread::Entry()
{
	while (true)
	{
		wxThread::Sleep(100);
		this->checkChanges();
	}
	/*
	while (oFrame->oProgressBar->GetValue() < 100)
	{
		if (TestDestroy())
		{
			printf("Failed to create thread for unknown reasons.\n");
			break;
		}
		
		increment(1);
		
		wxThread::Sleep(50);
	}
	*/
	
	return NULL;
}

